#include "DHT.h"
#include <Wire.h>
#include <LiquidCrystal.h>
#include <BMP085.h>
LiquidCrystal _lcd1(12, 11, 5, 4, 3, 2);
int _dispTempLength1=0;
boolean _isNeedClearDisp1;

DHT _dht1(7, DHT11);

BMP085  _bmp085 = BMP085();
long _bmp085P = 0;

int _disp1oldLength = 0;
unsigned long _dht1Tti = 0UL;
float _dht1t = 0.00;
float _dht1h = 0.00;
unsigned long _bmp0851Tti = 0UL;
int _disp2oldLength = 0;
void setup()
{
Wire.begin();
_bmp085.init();
_lcd1.begin(16, 2);
_dht1.begin();
}
void loop()
{if(_isTimer(_dht1Tti, 3000)) {
_dht1Tti = millis(); 
float tempDht7;
 tempDht7 = _dht1.readTemperature();
if (!(isnan(tempDht7))){_dht1t=tempDht7; }
 tempDht7 = _dht1.readHumidity();
if (!(isnan(tempDht7))){_dht1h=tempDht7; }
}if (_isNeedClearDisp1) {_lcd1.clear(); _isNeedClearDisp1= 0;}
if(_isTimer(_bmp0851Tti, 4000)) {
_bmp0851Tti = millis(); 
_bmp085.getPressure(&_bmp085P);
}



if (1) {
_dispTempLength1 = ((((String("T ")) + ((String((int(_dht1t))))) + (String(" C ")) + (String("- V ")) + ((String((int(_dht1h))))) + (String(" %"))))).length();
if (_disp1oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp1oldLength = _dispTempLength1;
_lcd1.setCursor(0, 0);
_lcd1.print((((String("T ")) + ((String((int(_dht1t))))) + (String(" C ")) + (String("- V ")) + ((String((int(_dht1h))))) + (String(" %")))));
} else {
if (_disp1oldLength > 0) {_isNeedClearDisp1 = 1; _disp1oldLength = 0;} 
}
if (1) {
_dispTempLength1 = ((((String("P ")) + (( _floatToStringWitRaz((_bmp085P)/(133.322),2))) + (String(" mmHG"))))).length();
if (_disp2oldLength > _dispTempLength1) {_isNeedClearDisp1 = 1;} 
_disp2oldLength = _dispTempLength1;
_lcd1.setCursor(int((16 - _dispTempLength1)/2), 1);
_lcd1.print((((String("P ")) + (( _floatToStringWitRaz((_bmp085P)/(133.322),2))) + (String(" mmHG")))));
} else {
if (_disp2oldLength > 0) {_isNeedClearDisp1 = 1; _disp2oldLength = 0;} 
}




}
bool _isTimer(unsigned long startTime, unsigned long period )
  {
  unsigned long currentTime;
currentTime = millis();
if (currentTime>= startTime) {return (currentTime>=(startTime + period));} else {return (currentTime >=(4294967295-startTime+period));}
  }
String  _floatToStringWitRaz(float value, int raz)
{
  float tv;
  int ti = int(value);
  String ts = String(ti);
  if (raz == 0) {
    return ts;
  }
  ts += ".";
  float tf = abs(value - ti);
  for (int i = 1; i <= raz; i++ )
  {
    tv = tf * 10;
    ti = int(tv);
    ts += String(ti);
    tf = (tv - ti);
  }
  return ts;
}
